$MODID51
$IC(MACROS51)
        SELECT	NONE
	COMMAND	#0FH
	COMMAND	#38H
	COMMAND	#01H
	COMMAND	#80H

	DISPCH  #'D'
	DISPCH  #'u'
	DISPCH  #'t'
	DISPCH  #'y'
	DISPCH  #':'
	COMMAND	#14H

	MCALL	GetNumber
	SELECT	PORTA
	CLRCTRL	2
	MOV	R1,#0
	MOV	DAT, R1
	CLRCTRL	3
	
	MOV	R2, #1
	MOV     1, #1
	MOV     A, #0
AGAIN:
	MOV	3, 2
DEL1:	DELAY	1
	DJNZ	R3, DEL1

        MOV	DAT, A

	CJNE	A, #255, MIDDLE          ; MIDDLE OF THE WAVE
	MOV	2, 4
	MOV     R1, #2

MIDDLE:	CJNE	A, #0, NEXT
	MOV	R2, #1
	MOV     R1, #1

NEXT:	
        CJNE    R1, #1, THEINC
        INC     A
        SJMP    AGAIN1
THEINC: DEC     A

AGAIN1:	SJMP	AGAIN

;---------- GET NUMEBR ---------------
GetNumber:

NOT_PRESSED1:
	IFKBHIT
	JNC		NOT_PRESSED1
	GETSCAN		A
	MOV		DPTR, #KeyTable
	MOVMEM		A, @A+DPTR
	DISPCH		A
	SUBB		A, #30H
	MOV		R1, A
L1:	IFKBHIT
	JC		L1

NOT_PRESSED2:
	IFKBHIT
	JNC		NOT_PRESSED2
	GETSCAN		A
	MOV		DPTR, #KeyTable
	MOVMEM		A, @A+DPTR
	DISPCH		A
	SUBB		A, #30H
	MOV		R2, A
L2:	IFKBHIT
	JC		L2

NOT_PRESSED3:
	IFKBHIT
	JNC		NOT_PRESSED3
	GETSCAN		A
	MOV		DPTR, #KeyTable
	MOVMEM		A, @A+DPTR
	DISPCH		A
	SUBB		A, #30H
	MOV		R3, A
L3:	IFKBHIT
	JC		L3

	MOV	A, R1
	MOV	B, #10
	MUL	AB
	
	ADD	A, R2
	MOV	B,#10
	MUL	AB

	ADD	A, R3
	MOV	R4,A

	RET

;----------------------------
KeyTable:	DB	'123P456U789DS0ME', 0

END
